    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ---------------
    028     * WindNeedle.java
    029     * ---------------
    030     * (C) Copyright 2002-2005, by the Australian Antarctic Division and
    031     *                          Contributors.
    032     *
    033     * Original Author:  Bryan Scott (for the Australian Antarctic Division);
    034     * Contributor(s):   David Gilbert (for Object Refinery Limited);
    035     *
    036     * $Id: WindNeedle.java,v 1.4.2.2 2005/10/25 20:50:49 mungady Exp $
    037     *
    038     * Changes:
    039     * --------
    040     * 25-Sep-2002 : Version 1, contributed by Bryan Scott (DG);
    041     * 09-Sep-2003 : Added equals() method (DG);
    042     *
    043     */
    044
    045    package org.jfree.chart.needle;
    046
    047    import java.awt.Graphics2D;
    048    import java.awt.geom.Point2D;
    049    import java.awt.geom.Rectangle2D;
    050    import java.io.Serializable;
    051
    052    /**
    053     * A needle that indicates wind direction, for use with the
    054     * {@link org.jfree.chart.plot.CompassPlot} class.
    055     *
    056     * @author Bryan Scott
    057     */
    058    public class WindNeedle extends ArrowNeedle
    059                                    implements Cloneable, Serializable {
    060
    061        /** For serialization. */
    062        private static final long serialVersionUID = -2861061368907167834L;
    063
    064        /**
    065         * Default constructor.
    066         */
    067        public WindNeedle() {
    068            super(false);  // isArrowAtTop
    069        }
    070
    071        /**
    072         * Draws the needle.
    073         *
    074         * @param g2  the graphics device.
    075         * @param plotArea  the plot area.
    076         * @param rotate  the rotation point.
    077         * @param angle  the angle.
    078         */
    079        protected void drawNeedle(Graphics2D g2, Rectangle2D plotArea,
    080                                  Point2D rotate, double angle) {
    081
    082            super.drawNeedle(g2, plotArea, rotate, angle);
    083            if ((rotate != null) && (plotArea != null)) {
    084
    085                int spacing = getSize() * 3;
    086                Rectangle2D newArea = new Rectangle2D.Double();
    087
    088                Point2D newRotate = rotate;
    089                newArea.setRect(
    090                    plotArea.getMinX() - spacing, plotArea.getMinY(),
    091                    plotArea.getWidth(), plotArea.getHeight()
    092                );
    093                super.drawNeedle(g2, newArea, newRotate, angle);
    094
    095                newArea.setRect(
    096                    plotArea.getMinX() + spacing, plotArea.getMinY(),
    097                    plotArea.getWidth(), plotArea.getHeight()
    098                );
    099                super.drawNeedle(g2, newArea, newRotate, angle);
    100
    101            }
    102        }
    103
    104        /**
    105         * Tests another object for equality with this object.
    106         *
    107         * @param object  the object to test.
    108         *
    109         * @return A boolean.
    110         */
    111        public boolean equals(Object object) {
    112            if (object == null) {
    113                return false;
    114            }
    115            if (object == this) {
    116                return true;
    117            }
    118            if (super.equals(object) && object instanceof WindNeedle) {
    119                return true;
    120            }
    121            return false;
    122        }
    123
    124    }
    125